'ATtiny85 Interface
$regfile = "attiny85.dat"
$crystal = 8000000
$hwstack = 8
$swstack = 4                                                ' 16
$framesize = 4

Dim Kom As Byte
Dim Dat As Byte
Dim U As Word
Dim Hi As Byte
Dim Lo As Byte
Dim N As Byte
Dim Nn As Word

Dim D(400) As Byte


Open "comb.2:9600,8,n,1" For Input As #1
Open "comb.1:9600,8,n,1" For Output As #2

Config Adc = Single , Prescaler = 16
Start Adc

Clkpr = 128                                                 '8 MHz
Clkpr = 0
Clkpr = 0

Ddrb = &B00000011

Do
  Get #1 , Kom
  If Kom = 1 Then
    Put #2 , 100
  End If
  If Kom = 16 Then
    Get #1 , Dat
    Dat = Dat And &B00011011
    Dat = Dat Or &B00000010
    Portb = Dat
  End If
  If Kom = 17 Then
    Get #1 , Dat
    Dat = Dat And &B00011011
    Dat = Dat Or &B00000010
    Ddrb = Dat
  End If
  If Kom = 18 Then
     Config Timer0 = Pwm , Prescale = 64 , Compare A Pwm = Clear Up
     Pwm0a = 0
  End If
  If Kom = 32 Then
     Dat = Pinb
     Put #2 , Dat
  End If
  If Kom = 48 Then
     U = Getadc(2)
     Shift U , Right , 2
     Put #2 , U
  End If
  If Kom = 49 Then
     U = Getadc(3)
     Shift U , Right , 2
     Put #2 , U
  End If
  If Kom = 56 Then
     U = Getadc(2)
     Hi = High(u)
     Lo = Low(u)
     Put #2 , Hi
     Put #2 , Lo
  End If
  If Kom = 57 Then
     U = Getadc(3)
     Hi = High(u)
     Lo = Low(u)
     Put #2 , Hi
     Put #2 , Lo
  End If
  If Kom = 64 Then
    Get #1 , Dat
    Pwm0a = Dat
  End If
 If Kom = 100 Then
    For Nn = 1 To 362
      U = Getadc(2)
      Shift U , Right , 2
      D(nn) = U
    Next Nn
    For Nn = 1 To 361
      Dat = D(nn)
      Put #2 , Dat
    Next Nn
  End If
  If Kom = 101 Then
    For N = 0 To 180
      U = Getadc(2)
      Shift U , Right , 2
      Nn = N * 2
      Nn = Nn + 1
      D(nn) = U
      U = Getadc(3)
      Shift U , Right , 2
      Nn = Nn + 1
      D(nn ) = U
    Next N
    For Nn = 1 To 362
      Dat = D(nn)
      Put #2 , Dat
    Next Nn
  End If
Loop

End